/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package pos;

import java.awt.GridLayout;
import java.util.List;
import model.Product;

/**
 *
 * @author Acer
 */
public class ProductListPanel extends javax.swing.JPanel implements onBuyProductListener {

    private final List<Product> productList;
    private POSPanel posPanel;

    /**
     * Creates new form ProductListPanel
     */
    public ProductListPanel() {
        initComponents();
        productList = Product.getProductList();
        for (Product product : productList) {
            ProductPanel panel = new ProductPanel(product);
            pnlProducts.add(panel);
            panel.addOnBuyListener(this);
        }
        int num = pnlProducts.getComponentCount();
        int col = 3;
        pnlProducts.setLayout(new GridLayout(num / col + (num % col > 0 ? 1 : 0), col));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSlider1 = new javax.swing.JSlider();
        scpProducts = new javax.swing.JScrollPane();
        pnlProducts = new javax.swing.JPanel();

        setBackground(new java.awt.Color(211, 197, 186));
        setForeground(new java.awt.Color(211, 197, 186));

        scpProducts.setBackground(new java.awt.Color(211, 197, 186));
        scpProducts.setBorder(null);
        scpProducts.setForeground(new java.awt.Color(211, 197, 186));
        scpProducts.setEnabled(false);

        pnlProducts.setBackground(new java.awt.Color(211, 197, 186));
        pnlProducts.setForeground(new java.awt.Color(211, 197, 186));

        javax.swing.GroupLayout pnlProductsLayout = new javax.swing.GroupLayout(pnlProducts);
        pnlProducts.setLayout(pnlProductsLayout);
        pnlProductsLayout.setHorizontalGroup(
            pnlProductsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 619, Short.MAX_VALUE)
        );
        pnlProductsLayout.setVerticalGroup(
            pnlProductsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 470, Short.MAX_VALUE)
        );

        scpProducts.setViewportView(pnlProducts);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(scpProducts)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(scpProducts, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JSlider jSlider1;
    private javax.swing.JPanel pnlProducts;
    private javax.swing.JScrollPane scpProducts;
    // End of variables declaration//GEN-END:variables

    @Override
    public void buy(Product product, int amount,int sweetLevel, String type) {
        posPanel.setOrderTable(product, amount, sweetLevel, type);
    }

    public void setPOSPanel(POSPanel posPanel) {
        this.posPanel = posPanel;
    }
}
